/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package dev.revington;

import com.fasterxml.jackson.core.JsonFactory;
import com.fasterxml.jackson.databind.JsonDeserializer;
import com.fasterxml.jackson.databind.JsonSerializer;
import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.json.JsonMapper;
import dev.revington.util.JSONDeseralizer;
import dev.revington.util.JSONSerializer;
import dev.revington.entities.MongoRecord;
import io.confluent.kafka.serializers.KafkaAvroSerializer;
import io.confluent.kafka.streams.serdes.avro.GenericAvroSerde;
import io.confluent.kafka.streams.serdes.avro.SpecificAvroSerde;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.net.ConnectException;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URI;
import java.net.URISyntaxException;
import java.net.URL;
import java.net.http.HttpClient;
import java.net.http.HttpRequest;
import java.net.http.HttpResponse;
import java.rmi.ConnectIOException;
import java.util.Collections;
import java.util.Map;
import java.util.Properties;
import java.util.concurrent.CountDownLatch;
import java.util.logging.Level;
import java.util.logging.Logger;
import java.util.regex.Pattern;
import org.apache.avro.Schema;
import org.apache.avro.SchemaBuilder;
import org.apache.avro.generic.GenericData;
import org.apache.avro.generic.GenericDatumReader;
import org.apache.avro.generic.GenericRecord;
import org.apache.avro.generic.GenericRecordBuilder;
import org.apache.avro.io.DatumReader;
import org.apache.avro.io.DecoderFactory;
import org.apache.avro.io.EncoderFactory;
import org.apache.avro.util.Utf8;
import org.apache.kafka.common.serialization.Serde;
import org.apache.kafka.common.serialization.Serdes;
import org.apache.kafka.common.serialization.StringDeserializer;
import org.apache.kafka.common.serialization.StringSerializer;
import org.apache.kafka.streams.KafkaStreams;
import org.apache.kafka.streams.KeyValue;
import org.apache.kafka.streams.StreamsBuilder;
import org.apache.kafka.streams.StreamsConfig;
import org.apache.kafka.streams.Topology;
import org.apache.kafka.streams.kstream.Consumed;
import org.apache.kafka.streams.kstream.KStream;
import org.apache.kafka.streams.kstream.Named;
import org.apache.kafka.streams.kstream.Produced;
import org.apache.kafka.streams.processor.TopicNameExtractor;
import org.json.JSONObject;

public class App {

    static Properties loadProps() throws IOException {
        Properties props = new Properties();
        props.load(App.class.getClassLoader().getResourceAsStream("streams.properties"));
        return props;
    }

    static String generateSchema(String json) {
        HttpClient client = HttpClient.newHttpClient();

        HttpRequest request = null;
        try {
            request = HttpRequest.newBuilder(new URI("http://www.dataedu.ca/avro/api/v1/json-doc-to-avro"))
                    .header("Content-Type", "application/json")
                    .POST(HttpRequest.BodyPublishers.ofString(json))
                    .build();
        } catch (URISyntaxException ex) {
            Logger.getLogger(App.class.getName()).log(Level.SEVERE, null, ex);
        }

        HttpResponse<String> resp = null;
        try {
            resp = client.send(request, HttpResponse.BodyHandlers.ofString());
        } catch (IOException ex) {
            Logger.getLogger(App.class.getName()).log(Level.SEVERE, null, ex);
        } catch (InterruptedException ex) {
            Logger.getLogger(App.class.getName()).log(Level.SEVERE, null, ex);
        }

        return resp.body();
    }

    static Logger logger = Logger.getLogger(App.class.getName());

    public static void main(String[] args) {
        Properties props = new Properties();

        try {
            props = loadProps();

            props.put(StreamsConfig.DEFAULT_KEY_SERDE_CLASS_CONFIG, Serdes.String().getClass());
            props.put(StreamsConfig.DEFAULT_VALUE_SERDE_CLASS_CONFIG, Serdes.String().getClass());
        } catch (IOException e) {
            e.printStackTrace();
            return;
        }

        final Map<String, String> serdeConfig = Collections.singletonMap("schema.registry.url",
                "http://schema-registry:8081");
        final Serde<GenericRecord> keyGenericAvroSerde = new GenericAvroSerde();
        keyGenericAvroSerde.configure(serdeConfig, true); // `true` for record keys
        final Serde<GenericRecord> valueGenericAvroSerde = new GenericAvroSerde();
        valueGenericAvroSerde.configure(serdeConfig, false); // `false` for record values 

        StreamsBuilder builder = new StreamsBuilder();

        KStream<GenericRecord, GenericRecord> mongo_stream = builder
                .stream(Pattern.compile("^(?=mongo_source_.*)((?!.*_sink_.*).+)$"), Consumed.with(keyGenericAvroSerde, valueGenericAvroSerde));

        TopicNameExtractor<GenericRecord, GenericRecord> extractor = (key, value, recordContext) -> {
            String topic = recordContext.topic();
            if (topic.startsWith("mongo")) {
                return recordContext.topic().replace("mongo_source_kafka_", "postgre_sink_");
            } else {
                return recordContext.topic().replace("postgre_source_.public.", "mongo_sink_");
            }
        };

        mongo_stream
                .map((key, record) -> {
                    System.out.println(record);
                    {
                        JSONObject rec = new JSONObject(((Utf8) record.get("documentKey")).toString());
                        key.put("_id", rec.getString("_id"));
                    }

                    String opType = null;
                    if ((opType = ((Utf8) record.get("operationType")).toString()).equals("delete") || opType.equals("drop")) {
                        return new KeyValue<>(key, null);
                    }

                    JSONObject data = new JSONObject(((Utf8) record.get("fullDocument")).toString().replaceAll("[$_]+", ""));
                    data.remove("id");

                    DecoderFactory DF = new DecoderFactory();
                    Schema schema = null;
                    try {
                        schema = Schema.parse(App.generateSchema(data.toString()));
                        schema.addProp("connect.name", "ChangeStream");
                    } catch (Exception e) {
                        System.out.println(e.getMessage());
                    }

                    try {
                        GenericRecord rec = new GenericData.Record(schema);
                        data.toMap().forEach((k, v) -> {
                            rec.put(k, v);
                        });

                        return new KeyValue<>(key, rec);
                    } catch (Exception e) {
                        System.out.println(e.getMessage());
                    }

                    return null;
                })
                .to(extractor, Produced.with(keyGenericAvroSerde, valueGenericAvroSerde));

        var postgre_stream = builder
                .stream(Pattern.compile("^(?=postgre_source_.*)((?!.*_sink_.*).+)$"), Consumed.with(keyGenericAvroSerde, valueGenericAvroSerde));

        postgre_stream
                .mapValues((key, record) -> {
                    System.out.println(key + " : " + record);
                    if (record == null || record.get("after") == null) {
                        return null;
                    }

                    JSONObject data = new JSONObject(record.get("after").toString());
                    Schema schema = Schema.parse(App.generateSchema(data.toString()));

                    GenericRecord rec = new GenericData.Record(schema);

                    data.toMap().forEach((k, v) -> {
                        rec.put(k, v);
                    });

                    return rec;
                })
                .to(extractor, Produced.with(keyGenericAvroSerde, valueGenericAvroSerde));

        Topology topology = builder.build();
        System.out.println(topology.describe());

        KafkaStreams streams = new KafkaStreams(topology, props);

        streams.setStateListener((newState, oldState) -> {
            System.out.println(oldState.name() + " -> " + newState.name());
        });

        Runtime.getRuntime().addShutdownHook(new Thread(streams::close));

        streams.start();
    }
}
